<?php

// Fix php.ini wrong error_reporting setting

@ini_set ( 'error_reporting', E_ALL ^ E_NOTICE );

// Version variables

$cjoverkill_version = "CjOverkill Version 5.3.1";
$cjoverkill_version_short = "531";

//cookie time to count uniques (in seconds)

$cookietime = 86400;

//maximum string lenght.

$strlen_max = 1024;

//internal functions. Do not edit unless you know what you do

function cjoverkill_connect () {
    global $cjoverkill_host;
    global $cjoverkill_user;
    global $cjoverkill_passwd;
    global $cjoverkill_db;
    global $cjoverkill_link;
    $cjoverkill_link = @mysqli_connect ( "$cjoverkill_host", "$cjoverkill_user", "$cjoverkill_passwd", "$cjoverkill_db" ) OR
            cjoverkill_print_error ( mysqli_connect_error () );
    // Fix MySQL version 8.x default configuration for strict query grouping.
    @mysqli_query ( $cjoverkill_link, "SET sql_mode=(SELECT REPLACE(@@sql_mode,'ONLY_FULL_GROUP_BY',''))" );
}

function cjoverkill_disconnect () {
    global $cjoverkill_link;
    @mysqli_close ( $cjoverkill_link ) OR
            cjoverkill_print_error ( "Could not close connection to MySQL." );
}

function cjoverkill_print_error ( $msg ) {
    echo "<font face='verdana' size='3'><b>Error:</b><br><font size='2'>$msg</font></font>";
    exit;
}

function cjoverkill_repair () {
    global $cjoverkill_link;
    global $site_id;
    if ( $site_id == "" || $site_id == 0 || !isset ( $site_id ) ) {
        $site_id = 1;
    }
    $tables = array ("cjoverkill_blacklist",
        "cjoverkill_cheatreports",
        "cjoverkill_country_log_in",
        "cjoverkill_country_log_out",
        "cjoverkill_daily",
        "cjoverkill_daily_totals",
        "cjoverkill_filter_base",
        "cjoverkill_filter_client",
        "cjoverkill_filter_country",
        "cjoverkill_filter_ip",
        "cjoverkill_filter_ipwhite",
        "cjoverkill_filter_method",
        "cjoverkill_forces",
        "cjoverkill_links",
        "cjoverkill_network_settings",
        "cjoverkill_reset",
        "cjoverkill_security",
        "cjoverkill_sites",
        "cjoverkill_sites_settings",
        "cjoverkill_stats",
        "cjoverkill_trades",
        "cjoverkill_warnings"
    );
    for ( $i = 0; $i < count ( $tables ); $i++ ) {
        $table = $tables[$i];
        $sql1 = @mysqli_query ( $cjoverkill_link, "REPAIR TABLE $table" ) OR cjoverkill_print_error ( mysqli_error ( $cjoverkill_link ) );
    }
    $sql1 = @mysqli_query ( $cjoverkill_link, "REPAIR TABLE cjoverkill_iplog_in_$site_id" ) OR cjoverkill_print_error ( mysqli_error ( $cjoverkill_link ) );
    $sql1 = @mysqli_query ( $cjoverkill_link, "REPAIR TABLE cjoverkill_iplog_out_$site_id" ) OR cjoverkill_print_error ( mysqli_error ( $cjoverkill_link ) );
    $sql1 = @mysqli_query ( $cjoverkill_link, "REPAIR TABLE cjoverkill_ref_$site_id" ) OR cjoverkill_print_error ( mysqli_error ( $cjoverkill_link ) );
}

function cjoverkill_db_error ( $msg ) {
    global $cjoverkill_link;
    global $site_id;
    $stime = localtime ();
    $thishour = $stime[2];
    $norepair = 0;
    if ( $site_id == "" || $site_id == 0 || !isset ( $site_id ) ) {
        $site_id = 1;
    }
    $norep = array ("Deadlock found",
        "try restarting transaction",
        "Lock wait timeout");
    for ( $i = 0; $i < count ( $norep ); $i++ ) {
        $str = $norep[$i];
        $str_aux = strtolower ( $str );
        if ( stristr ( $msg, $str_aux ) ) {
            $norepair = 1;
        }
    }
    if ( $norepair == 0 ) {
        cjoverkill_repair ();
        $emerg = "Emergency Repair: $msg";
        /* @mysqli_query($cjoverkill_link, "INSERT INTO cjoverkill_warnings (site_id, fecha, what, hour) VALUES ('$site_id', NOW(), '$emerg', '$thishour')") OR
          cjoverkill_print_error(mysqli_error($cjoverkill_link)); */
        cjoverkill_warn_log ( $emerg, 1 );
        $tms = "OOOPS! Something wrong happened. Please reload the page you are visiting.<br>
    		Transcription follows:<br>
    	$msg <br>";
        cjoverkill_print_error ( $tms );
    }
}

function cjoverkill_warn_log ( $msg, $warn_level = 1 ) {
    /**
     * cjoverkill_print_error is used to avoid cyclic references with cjoverkill_db_error
     * 
     * * Warn levels
     * 1 = Critical
     * 2 = Error
     * 3 = Warning
     * 4 = Info
     * 11 = trade info (add from trade.php)
     * 12 = trade warn (autodisable)
     * 13 = trade info (add/edit/delete from admin)
     * 21 = site info
     * 22 = site warn
     */
    global $site_id;
    global $cjoverkill_link;
    if ( !isset ( $site_id ) || $site_id == "" || $site_id == 0 ) {
        $site_id = 1;
    }
    $msg = cjoverkill_sanityze ( $msg );
    $stime = localtime ();
    $thishour = $stime[2];

    @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_warnings SET fecha_last=NOW(), warn_times=warn_times+1 WHERE site_id='$site_id' AND what='$msg' AND warn_level='$warn_level'" ) OR cjoverkill_print_error ( mysqli_error ( $cjoverkill_link ) );
    if ( @mysqli_affected_rows ( $cjoverkill_link ) == 0 ) {
        $warn_times = 1;
        @mysqli_query ( $cjoverkill_link, "INSERT INTO cjoverkill_warnings (site_id, fecha_first, fecha_last, what, warn_times, hour, warn_level)
						VALUES ('$site_id', NOW(), NOW(), '$msg', '$warn_times', '$thishour', '$warn_level')" ) OR
                cjoverkill_print_error ( mysqli_error ( $cjoverkill_link ) );
    }
}

function cjoverkill_sanityze ( $str ) {
    global $cjoverkill_link;
    $forbidden = array ("<", // HTML + logical operator
        ">", // HTML + logical operator
        "'", // SQL string operator
        "\"" // SQL string operator
            //		     "%" // SQL string operator
            //		     "&gt", // special character
            //		     "&lt", // special character
            //		     ";" // Commands terminator for lots of prog languages
    );
    for ( $i = 0; $i < count ( $forbidden ); $i++ ) {
        $repl = $forbidden[$i];
        $str = str_replace ( "$repl", "", $str );
    }
    $str_aux = substr ( $str, 0, 249 );
    $str_aux = mysqli_real_escape_string ( $cjoverkill_link, $str_aux );
    $str = $str_aux;
    return ($str);
}

function cjoverkill_adm_sanityze ( $str ) {
    global $cjoverkill_link;
    /**
     * Admin interface sanity checks
     */
    $str_aux = mysqli_real_escape_string ( $cjoverkill_link, $str );
    $str = $str_aux;
    return ($str);
}

function cjoverkill_check_url ( $url ) {
    $regex = "/^((https?|ftp)\:\/\/)?"; // SCHEME
    $regex .= "([a-zA-Z0-9+!*(),;?&=\$_.-]+(\:[a-zA-Z0-9+!*(),;?&=\$_.-]+)?@)?"; // User and Pass
    $regex .= "([a-zA-Z0-9-.]*)\.([a-zA-Z]{2,6})"; // Host or IP
    $regex .= "(\:[0-9]{2,5})?"; // Port
    $regex .= "(\/([a-zA-Z0-9+\$_-]\.?)+)*\/?"; // Path
    $regex .= "(\?[a-zA-Z+&\$_.-][a-zA-Z0-9;:@&%=+\/\$_.-]*)?"; // GET Query
    $regex .= "(#[a-zA-Z_.-][a-zA-Z0-9+\$_.-]*)?$/"; // Anchor
    return preg_match ( $regex, $url );
}

function cjoverkill_ip_normalize ( $ip ) {
    $invalid_ip = "0:0:0:0:0:ffff:0000:0001";
    $ip = strtolower ( $ip );
    if ( !filter_var ( $ip, FILTER_VALIDATE_IP ) ) {
        return $invalid_ip;
    }
    if ( filter_var ( $ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6 ) ) {
        return $ip;
    }
    $bytes = array_map ( 'dechex', explode ( '.', $ip ) );
    return strtolower ( vsprintf ( '0:0:0:0:0:ffff:%02s%02s:%02s%02s', $bytes ) );
}

function cjoverkill_site_discover ( $site_dom ) {
    global $cjoverkill_link;
    $site_dom = strtolower ( $site_dom );
    $site_dom = preg_replace ( "/^www\./", "", $site_dom );
    $sql = @mysqli_query ( $cjoverkill_link, "SELECT site_id FROM cjoverkill_sites WHERE site_domain='$site_dom' LIMIT 1" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    if ( @mysqli_num_rows ( $sql ) == 0 ) {
        $site_id = 1;
    } else {
        $tmp = @mysqli_fetch_array ( $sql );
        extract ( $tmp );
    }
    return($site_id);
}

function cjoverkill_trade_discover ( $vtrade_id, $site_id ) {
    global $cjoverkill_link;
    $sql = @mysqli_query ( $cjoverkill_link, "SELECT trade_id FROM cjoverkill_trades WHERE vtrade_id='$vtrade_id' AND site_id='$site_id'" ) OR
            cjoverkill_print_error ( mysqli_error ( $cjoverkill_link ) );
    if ( @mysqli_num_rows ( $sql ) == 0 ) {
        $site_id = 1;
        $vtrade_id = 3;
        $sql = @mysqli_query ( $cjoverkill_link, "SELECT trade_id FROM cjoverkill_trades WHERE vtrade_id='$vtrade_id' AND site_id='$site_id'" ) OR
                cjoverkill_print_error ( mysqli_error ( $cjoverkill_link ) );
    }
    $tmp = mysqli_fetch_array ( $sql );
    extract ( $tmp );
    return($trade_id);
}

function cjoverkill_base64_discover ( $site_id ) {
    global $cjoverkill_link;
    $sql = @mysqli_query ( $cjoverkill_link, "SELECT site_base64 FROM cjoverkill_sites WHERE site_id='$site_id'" ) OR
            cjoverkill_print_error ( mysqli_error ( $cjoverkill_link ) );
    if ( @mysqli_num_rows ( $sql ) == 0 ) {
        $site_base64 = 0;
    } else {
        $tmp = @mysqli_fetch_array ( $sql );
        extract ( $tmp );
    }
    return($site_base64);
}

function cjoverkill_cheats ( $site_id ) {
    global $cjoverkill_link;
    $cheat1 = "N";
    $cheat2 = "N";
    $cheat3 = "N";
    $cheat4 = "N";
    $cheat5 = "N";
    $stime = localtime ();
    $thishour = $stime[2];
    $next_hour = mktime ( $stime[2] + 1, 0, 0, date ( "m" ), date ( "d" ), date ( "Y" ) );
    //$filter_id=cjoverkill_trade_discover(5,$site_id);
    $sql = @mysqli_query ( $cjoverkill_link, "SELECT min_uniq,px_enable,ip_enable,clicks_enable,cheatstart FROM cjoverkill_sites WHERE site_id='$site_id'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    $tmp = @mysqli_fetch_array ( $sql );
    extract ( $tmp );
    $sql = @mysqli_query ( $cjoverkill_link, "SELECT cjoverkill_trades.trade_id, max_prod, min_prod, max_px, max_clicks, max_ip, status,
			uniq_in0+uniq_in1+uniq_in2+uniq_in3+uniq_in4+uniq_in5+uniq_in6+uniq_in7+uniq_in8+uniq_in9+uniq_in10+
			uniq_in11+uniq_in12+uniq_in13+uniq_in14+uniq_in15+uniq_in16+uniq_in17+uniq_in18+uniq_in19+uniq_in20+
			uniq_in21+uniq_in22+uniq_in23 AS uniq_day,
			clicks0+clicks1+clicks2+clicks3+clicks4+clicks5+clicks6+clicks7+clicks8+clicks9+clicks10+
			clicks11+clicks12+clicks13+clicks14+clicks15+clicks16+clicks17+clicks18+clicks19+clicks20+
			clicks21+clicks22+clicks23 AS clicks_day,
			raw_in0+raw_in1+raw_in2+raw_in3+raw_in4+raw_in5+raw_in6+raw_in7+raw_in8+raw_in9+raw_in10+
			raw_in11+raw_in12+raw_in13+raw_in14+raw_in15+raw_in16+raw_in17+raw_in18+raw_in19+raw_in20+
			raw_in21+raw_in22+raw_in23 AS raw_day
			FROM cjoverkill_stats, cjoverkill_trades WHERE
			cjoverkill_stats.site_id=cjoverkill_trades.site_id AND
			cjoverkill_trades.site_id='$site_id' AND
			cjoverkill_stats.trade_id=cjoverkill_trades.trade_id AND
			cjoverkill_trades.vtrade_id>'50' AND
			(status='1' OR status='2') AND
			boost!='1' AND
			overkill!='1'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    while ( $tmp = @mysqli_fetch_array ( $sql ) ) {
        extract ( $tmp );
        $min_prod = $min_prod / 100;
        $max_prod = $max_prod / 100;
        $tmp_status = $status;
        $what = "";
        $cheat1 = "N"; // Minimum hits
        $cheat2 = "N"; // Productivity
        $cheat3 = "N"; // Proxy
        $cheat4 = "N"; // Clicks
        $cheat5 = "N"; // Same IP hits
        // Minimum hits
        if ( $uniq_day < $min_uniq ) {
            $tmp_status = "2";
            $cheat1 = "Y";
        } elseif ( $uniq_day >= $min_uniq ) {
            $tmp_status = "1";
        }
        // Productivity
        if ( $uniq_day != 0 && $uniq_day >= $cheatstart && $cheat1 == "N" ) {
            $prod = $clicks_day / $uniq_day;
            if ( $prod < $min_prod || $prod > $max_prod ) {
                $tmp_status = "2";
                $cheat2 = "Y";
                $what = $what . " Productivity out of range. ";
            } else {
                $tmp_status = "1";
            }
        }
        // Proxy
        if ( isset ( $px_enable ) && $px_enable == "1" && $raw_day >= $cheatstart && $cheat1 == "N" && $cheat2 == "N" ) {
            $tmp_sql1 = @mysqli_query ( $cjoverkill_link, "SELECT sum(raw_in) AS px FROM cjoverkill_iplog_in_$site_id WHERE
				    				proxy!='' AND
				    				raw_in>0 AND
				    				trade_id='$trade_id'" ) OR
                    cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
            $tmp1 = @mysqli_fetch_array ( $tmp_sql1 );
            extract ( $tmp1 );
            $tmp_sql2 = @mysqli_query ( $cjoverkill_link, "SELECT sum(raw_in) AS all_raw FROM cjoverkill_iplog_in_$site_id WHERE
				     				raw_in>0 AND
				     				trade_id='$trade_id'" ) OR
                    cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
            $tmp2 = @mysqli_fetch_array ( $tmp_sql2 );
            extract ( $tmp2 );
            if ( $px > 0 && $all_raw > 0 ) {
                $px_pct = ($px / $all_raw) * 100;
                if ( $px_pct > $max_px ) {
                    $tmp_status = "2";
                    $cheat3 = "Y";
                    $what = $what . "Maximum proxy percent for visitors exceeded. ";
                }
            }
        }
        // Clicks
        if ( isset ( $clicks_enable ) && $clicks_enable == "1" && $raw_day >= $cheatstart ) {
            $tmp_sql3 = @mysqli_query ( $cjoverkill_link, "SELECT COUNT(*) AS cheated_clicks FROM cjoverkill_iplog_in_$site_id WHERE
				     			clicks>=$max_clicks AND
				     			trade_id='$trade_id'" ) OR
                    cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
            $tmp3 = @mysqli_fetch_array ( $tmp_sql3 );
            extract ( $tmp3 );
            $tmp_sql3f = @mysqli_query ( $cjoverkill_link, "SELECT COUNT(*) AS cheated_clicksf FROM cjoverkill_iplog_in_$site_id WHERE
				     			clicks>=$max_clicks AND
				     			ftrade_id='$trade_id'" ) OR
                    cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
            $tmp3f = @mysqli_fetch_array ( $tmp_sql3f );
            extract ( $tmp3f );
            if ( $cheated_clicks >= 1 || $cheated_clicksf >= 1 ) {
                $tmp_status = "2";
                $cheat4 = "Y";
                $what = $what . "Sent surfer who clicked too many times. ";
            }
        }
        // Same IP hits
        if ( isset ( $ip_enable ) && $ip_enable == "1" && $raw_day >= $cheatstart ) {
            $tmp_sql4 = @mysqli_query ( $cjoverkill_link, "SELECT COUNT(*) AS cheated_ips FROM cjoverkill_iplog_in_$site_id WHERE
				     			raw_in>=$max_ip AND
				     			trade_id='$trade_id'" ) OR
                    cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
            $tmp4 = @mysqli_fetch_array ( $tmp_sql4 );
            extract ( $tmp4 );
            $tmp_sql4f = @mysqli_query ( $cjoverkill_link, "SELECT COUNT(*) AS cheated_ipsf FROM cjoverkill_iplog_in_$site_id WHERE
				     			raw_in>=$max_ip AND
				     			ftrade_id='$trade_id'" ) OR
                    cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
            $tmp4f = @mysqli_fetch_array ( $tmp_sql4f );
            extract ( $tmp4f );
            if ( $cheated_ips >= 1 || $cheated_ipsf >= 1 ) {
                $tmp_status = "2";
                $cheat5 = "Y";
                $what = $what . "Sent the same surfer too many times. ";
            }
        }
        // Global cheating checker
        if ( $cheat1 == "Y" || $cheat2 == "Y" || $cheat3 == "Y" || $cheat4 == "Y" || $cheat5 == "Y" ) {
            $tmp_status = "2";
            if ( $cheat2 == "Y" || $cheat3 == "Y" || $cheat4 == "Y" || $cheat5 == "Y" ) {
                @mysqli_query ( $cjoverkill_link, "INSERT INTO cjoverkill_cheatreports (site_id, trade_id, hour, what) VALUES
			       			('$site_id', '$trade_id', '$thishour', '$what')" ) OR
                        cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
            }
        } else {
            $tmp_status = "1";
        }
        @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_trades SET status='$tmp_status' WHERE trade_id='$trade_id'" ) OR
                cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    }
}

function cjoverkill_toplist ( $site_id ) {
    global $cjoverkill_link;
    $sql = @mysqli_query ( $cjoverkill_link, "SELECT toplist AS prefix_path, toplist_generate, toplist_trades FROM cjoverkill_sites WHERE site_id='$site_id'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    if ( @mysqli_num_rows ( $sql ) != 0 ) {
        $tmp = mysqli_fetch_array ( $sql );
        extract ( $tmp );
        $prefix = "" . $prefix_path . "/";
        if ( $toplist_generate == 1 ) {
            $sql = @mysqli_query ( $cjoverkill_link, "SELECT domain,site_name, site_desc, custom_field, url AS site_url,
						uniq_in0+uniq_in1+uniq_in2+uniq_in3+uniq_in4+uniq_in5+uniq_in6+uniq_in7+uniq_in8+uniq_in9+uniq_in10+
						uniq_in11+uniq_in12+uniq_in13+uniq_in14+uniq_in15+uniq_in16+uniq_in17+uniq_in18+uniq_in19+uniq_in20+
						uniq_in21+uniq_in22+uniq_in23 AS uniq_day,
						uniq_out0+uniq_out1+uniq_out2+uniq_out3+uniq_out4+uniq_out5+uniq_out6+uniq_out7+uniq_out8+uniq_out9+uniq_out10+
						uniq_out11+uniq_out12+uniq_out13+uniq_out14+uniq_out15+uniq_out16+uniq_out17+uniq_out18+uniq_out19+uniq_out20+
						uniq_out21+uniq_out22+uniq_out23 AS out_day FROM
						cjoverkill_stats, cjoverkill_trades WHERE
						cjoverkill_stats.trade_id=cjoverkill_trades.trade_id AND
						cjoverkill_trades.site_id='$site_id' AND
						cjoverkill_trades.vtrade_id>'50' AND
						toplist='1' AND
						(status='1' OR status='3') ORDER BY
						uniq_day DESC LIMIT $toplist_trades" ) OR
                    cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
            if ( @mysqli_num_rows ( $sql ) == 0 ) {
                $warn_level = 22;
                $msg = "No trades found to populate the toplist. Check site settings and disable toplist generation if you don't want toplist";
                cjoverkill_warn_log ( $msg, $warn_level );
            } else {
                while ( $tmp = mysqli_fetch_array ( $sql ) ) {
                    extract ( $tmp );
                    $sites["$domain"] = $site_name;
                    $descs["$domain"] = $site_desc;
                    $uniqs["$domain"] = $uniq_day;
                    $outs["$domain"] = $out_day;
                    $urls["$domain"] = $site_url;
                    $custom_fields["$domain"] = $custom_field;
                }
                if ( is_dir ( $prefix ) ) {
                    $fdir = @opendir ( $prefix ) OR
                            cjoverkill_print_error ( "Could not open directory \"$prefix\"<BR> Make sure it exist and it is writable" );
                    while ( ($tfile = readdir ( $fdir )) !== FALSE ) {
                        if ( substr ( $tfile, -6 ) == ".templ" ) {
                            $toplists[] = $tfile;
                        }
                    }
                    closedir ( $fdir );
                    for ( $i = 0; $i < sizeof ( $toplists ); $i++ ) {
                        $template = implode ( "", file ( $prefix . "$toplists[$i]" ) );
                        reset ( $uniqs );
                        for ( $a = 1; $a <= $toplist_trades; $a++ ) {
                            $ky = key ( $uniqs );
                            if ( $ky == "" ) {
                                $ky = "Your Site Here";
                                $lnk = "<a href=\"trade.php\">$ky</a>";
                                $hardlnk = $lnk;
                            } else {
                                $lnk = "<a href=\"out.php?trade=$ky\">$sites[$ky]</a>";
                                $hardlnk = "<a href=\"$urls[$ky]\">$sites[$ky]</a>";
                            }
                            $template = str_replace ( "##sitename$a##", $sites["$ky"], $template );
                            $template = str_replace ( "##sitedesc$a##", $descs["$ky"], $template );
                            $template = str_replace ( "##in$a##", $uniqs["$ky"], $template );
                            $template = str_replace ( "##out$a##", $outs["$ky"], $template );
                            $template = str_replace ( "##sitedomain$a##", "$ky", $template );
                            $template = str_replace ( "##link$a##", "$lnk", $template );
                            $template = str_replace ( "##siteurl$a##", $urls["$ky"], $template );
                            $template = str_replace ( "##hardlink$a##", "$hardlnk", $template );
                            $template = str_replace ( "##customfield$a##", $custom_fields["$ky"], $template );
                            next ( $uniqs );
                        }
                        $tml = str_replace ( ".templ", ".html", $toplists[$i] );
                        $topfile = "" . $prefix . $tml . "";
                        $tfile = @fopen ( $prefix . "$tml", "w" ) OR
                                cjoverkill_warn_log ( "Could not open \"$topfile\". Make sure it exists and is writable or the toplist directory is writable.", 22 );
                        @fputs ( $tfile, "$template" );
                        @fclose ( $tfile );
                    }
                } else {
                    $warn_level = 22;
                    $msg = "This site toplist directory does not exist. Make sure your settings are correct and that the toplist directory is wrotable.";
                    cjoverkill_warn_log ( $msg, $warn_level );
                }
            }
        }
    }
}

function cjoverkill_logprune ( $site_id, $log_prune ) {
    global $cjoverkill_link;
    $stime = localtime ();
    $thishour = $stime[2];
    $next_prune = mktime ( $stime[2] + $log_prune, 0, 0, date ( "m" ), date ( "d" ), date ( "Y" ) );
    @mysqli_query ( $cjoverkill_link, "TRUNCATE TABLE cjoverkill_iplog_in_$site_id" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    @mysqli_query ( $cjoverkill_link, "TRUNCATE TABLE cjoverkill_iplog_out_$site_id" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    @mysqli_query ( $cjoverkill_link, "TRUNCATE TABLE cjoverkill_ref_$site_id" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_reset SET rst_log='$next_prune' WHERE site_id='$site_id'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
}

function cjoverkill_hourly ( $site_id ) {
    global $cjoverkill_link;
    //	global $site_id;
    $stime = localtime ();
    $thishour = $stime[2];
    $next_hour = mktime ( $stime[2] + 1, 0, 0, date ( "m" ), date ( "d" ), date ( "Y" ) );
    @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_reset SET rst_h='$next_hour' WHERE site_id='$site_id'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_stats SET raw_in$thishour=0, uniq_in$thishour=0, clicks$thishour=0,
    			raw_out$thishour=0, uniq_out$thishour=0 WHERE site_id='$site_id'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_forces SET h$thishour=0 WHERE site_id='$site_id'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_links SET h$thishour=0 WHERE site_id='$site_id'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );

    @mysqli_query ( $cjoverkill_link, "DELETE FROM cjoverkill_iplog_in_$site_id WHERE hour='$thishour'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    @mysqli_query ( $cjoverkill_link, "DELETE FROM cjoverkill_iplog_out_$site_id WHERE hour='$thishour'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );

    @mysqli_query ( $cjoverkill_link, "DELETE FROM cjoverkill_ref_$site_id WHERE hour='$thishour'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    @mysqli_query ( $cjoverkill_link, "DELETE FROM cjoverkill_filter_ip WHERE hour='$thishour' AND auto='1'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    @mysqli_query ( $cjoverkill_link, "DELETE FROM cjoverkill_cheatreports WHERE hour='$thishour' AND site_id='$site_id'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
}

function cjoverkill_daily ( $site_id ) {
    global $cjoverkill_link;
    $today = date ( "Y-m-d", mktime ( 0, 0, 0, date ( "m" ), date ( "d" ) - 1, date ( "Y" ) ) );
    $tomorrow = mktime ( 0, 0, 0, date ( "m" ), date ( "d" ) + 1, date ( "Y" ) );
    @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_reset SET rst_d='$tomorrow' WHERE site_id='$site_id'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    $sql = @mysqli_query ( $cjoverkill_link, "SELECT sum(raw_in0+raw_in1+raw_in2+raw_in3+raw_in4+raw_in5+raw_in6+raw_in7+raw_in8+raw_in9+raw_in10+
				  raw_in11+raw_in12+raw_in13+raw_in14+raw_in15+raw_in16+raw_in17+raw_in18+raw_in19+raw_in20+
				  raw_in21+raw_in22+raw_in23) AS raw_day,
			sum(uniq_in0+uniq_in1+uniq_in2+uniq_in3+uniq_in4+uniq_in5+uniq_in6+uniq_in7+uniq_in8+uniq_in9+uniq_in10+
			    uniq_in11+uniq_in12+uniq_in13+uniq_in14+uniq_in15+uniq_in16+uniq_in17+uniq_in18+uniq_in19+uniq_in20+
			    uniq_in21+uniq_in22+uniq_in23) AS uniq_day,
			sum(clicks0+clicks1+clicks2+clicks3+clicks4+clicks5+clicks6+clicks7+clicks8+clicks9+clicks10+
			    clicks11+clicks12+clicks13+clicks14+clicks15+clicks16+clicks17+clicks18+clicks19+clicks20+
			    clicks21+clicks22+clicks23) AS clicks_day,
			sum(raw_out0+raw_out1+raw_out2+raw_out3+raw_out4+raw_out5+raw_out6+raw_out7+raw_out8+raw_out9+raw_out10+
				raw_out11+raw_out12+raw_out13+raw_out14+raw_out15+raw_out16+raw_out17+raw_out18+raw_out19+raw_out20+
				raw_out21+raw_out22+raw_out23) AS rout_day,
			sum(uniq_out0+uniq_out1+uniq_out2+uniq_out3+uniq_out4+uniq_out5+uniq_out6+uniq_out7+uniq_out8+uniq_out9+uniq_out10+uniq_out11+uniq_out12+
			    uniq_out13+uniq_out14+uniq_out15+uniq_out16+uniq_out17+uniq_out18+uniq_out19+uniq_out20+uniq_out21+uniq_out22+uniq_out23) AS uout_day
			FROM cjoverkill_stats WHERE
			site_id='$site_id'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    $tmp = @mysqli_fetch_array ( $sql );
    extract ( $tmp );
    @mysqli_query ( $cjoverkill_link, "INSERT INTO cjoverkill_daily (site_id, fecha, raw_in, uniq_in, clicks, raw_out, uniq_out)
      VALUES ('$site_id', '$today', '$raw_day', '$uniq_day', '$clicks_day', '$rout_day', '$uout_day')" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    @mysqli_query ( $cjoverkill_link, "DELETE FROM cjoverkill_links WHERE h0+h1+h2+h3+h4+h5+h6+h7+h8+h9+h10+h11+h12+
		   h13+h14+h15+h16+h17+h18+h19+h20+h21+h22+h23=0 AND
		   site_id='$site_id'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    @mysqli_query ( $cjoverkill_link, "DELETE FROM cjoverkill_country_log_in WHERE site_id='$site_id'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    @mysqli_query ( $cjoverkill_link, "DELETE FROM cjoverkill_country_log_out WHERE site_id='$site_id'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    @mysqli_query ( $cjoverkill_link, "DELETE FROM cjoverkill_daily WHERE to_days(NOW())-to_days(fecha)>365 AND site_id='$site_id'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
}

function cjoverkill_dalyglobal () {
    global $cjoverkill_link;
    $today = date ( "Y-m-d", mktime ( 0, 0, 0, date ( "m" ), date ( "d" ) - 1, date ( "Y" ) ) );
    $tomorrow = mktime ( 0, 0, 0, date ( "m" ), date ( "d" ) + 1, date ( "Y" ) );
    @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_network_settings SET net_rst_d='$tomorrow'" ) OR cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    $sql = @mysqli_query ( $cjoverkill_link, "SELECT sum(raw_in0+raw_in1+raw_in2+raw_in3+raw_in4+raw_in5+raw_in6+raw_in7+raw_in8+raw_in9+raw_in10+
				  raw_in11+raw_in12+raw_in13+raw_in14+raw_in15+raw_in16+raw_in17+raw_in18+raw_in19+raw_in20+
				  raw_in21+raw_in22+raw_in23) AS raw_day,
			sum(uniq_in0+uniq_in1+uniq_in2+uniq_in3+uniq_in4+uniq_in5+uniq_in6+uniq_in7+uniq_in8+uniq_in9+uniq_in10+
			    uniq_in11+uniq_in12+uniq_in13+uniq_in14+uniq_in15+uniq_in16+uniq_in17+uniq_in18+uniq_in19+uniq_in20+
			    uniq_in21+uniq_in22+uniq_in23) AS uniq_day,
			sum(clicks0+clicks1+clicks2+clicks3+clicks4+clicks5+clicks6+clicks7+clicks8+clicks9+clicks10+
			    clicks11+clicks12+clicks13+clicks14+clicks15+clicks16+clicks17+clicks18+clicks19+clicks20+
			    clicks21+clicks22+clicks23) AS clicks_day,
			sum(raw_out0+raw_out1+raw_out2+raw_out3+raw_out4+raw_out5+raw_out6+raw_out7+raw_out8+raw_out9+raw_out10+
				raw_out11+raw_out12+raw_out13+raw_out14+raw_out15+raw_out16+raw_out17+raw_out18+raw_out19+raw_out20+
				raw_out21+raw_out22+raw_out23) AS rout_day,
			sum(uniq_out0+uniq_out1+uniq_out2+uniq_out3+uniq_out4+uniq_out5+uniq_out6+uniq_out7+uniq_out8+uniq_out9+uniq_out10+uniq_out11+uniq_out12+
			    uniq_out13+uniq_out14+uniq_out15+uniq_out16+uniq_out17+uniq_out18+uniq_out19+uniq_out20+uniq_out21+uniq_out22+uniq_out23) AS uout_day
			FROM cjoverkill_stats" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    $tmp = @mysqli_fetch_array ( $sql );
    extract ( $tmp );
    @mysqli_query ( $cjoverkill_link, "INSERT INTO cjoverkill_daily_totals (fecha, raw_in, uniq_in, clicks, raw_out, uniq_out)
      VALUES ('$today', '$raw_day', '$uniq_day', '$clicks_day', '$rout_day', '$uout_day')" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    @mysqli_query ( $cjoverkill_link, "DELETE FROM cjoverkill_daily_totals WHERE to_days(NOW())-to_days(fecha)>365" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    @mysqli_query ( $cjoverkill_link, "DELETE FROM cjoverkill_security WHERE to_days(NOW())-to_days(fecha)>7" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    @mysqli_query ( $cjoverkill_link, "DELETE FROM cjoverkill_warnings WHERE to_days(NOW())-to_days(fecha_last)>7" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
}

?>
